"use strict";

function _interopDefault(ex) {
  return ex && "object" == typeof ex && "default" in ex ? ex.default : ex;
}

Object.defineProperty(exports, "__esModule", {
  value: !0
});

var experimentalUtils = require("@typescript-eslint/experimental-utils"), prettier = _interopDefault(require("prettier")), path = _interopDefault(require("path"));

const createRule = experimentalUtils.ESLintUtils.RuleCreator(name => `${name}.md`), messages = {
  unformatted: "The content of this is not formatted"
}, tags = {
  js: !0,
  ts: !0,
  tsx: !0
}, rules = {
  format: createRule({
    name: "format",
    defaultOptions: [],
    meta: {
      docs: {
        category: "Stylistic Issues",
        description: "",
        recommended: "error"
      },
      messages: messages,
      schema: [],
      type: "layout",
      fixable: "whitespace"
    },
    create: context => ({
      TaggedTemplateExpression(node) {
        if ("Identifier" === node.tag.type && node.tag.name in tags && 0 === node.quasi.expressions.length) {
          const str = node.quasi.quasis[0].value.cooked, indentation = "".padEnd(node.tag.loc.start.column + 2), lines = prettier.format(str, {
            filepath: path.join(path.dirname(context.getFilename()), `lint.${node.tag.name}`)
          }).split("\n"), formatted = "\n" + lines.map((line, i) => i === lines.length - 1 ? "".padEnd(node.tag.loc.start.column) + line : "" === line ? "" : indentation + line).join("\n");
          formatted !== str && context.report({
            messageId: "unformatted",
            node: node.tag,
            fix: fixer => fixer.replaceText(node.quasi, `\`${formatted}\``)
          });
        }
      }
    })
  })
};

exports.rules = rules;
